﻿using System.Net;
using System.Net.Sockets;
using System.Text;

namespace Server;

internal class Server
{
	static void Main(string[] args)
	{
		Socket serverSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
		serverSocket.Bind(new IPEndPoint(IPAddress.Parse("127.0.0.1"), 20000));
		serverSocket.Listen(10);

		Socket clientSocket = serverSocket.Accept();
		Console.WriteLine(clientSocket.RemoteEndPoint);

		byte[] buffer1 = new byte[6];
		int n1 = clientSocket.Receive(buffer1, SocketFlags.None);
		Console.WriteLine(Encoding.UTF8.GetString(buffer1));

		byte[] buffer2 = new byte[256];
		int n2 = clientSocket.Receive(buffer2, 2, 100, SocketFlags.OutOfBand); // OOB 활성화 시 1바이트만 읽어옴
		Console.WriteLine("OOB data length: " + n2);

		int n3 = clientSocket.Receive(buffer2, 0, 2, SocketFlags.None);
		Console.WriteLine(Encoding.UTF8.GetString(buffer2));

		Console.ReadLine();
	}
}